CAD开发者社区

 找回密码
 立即注册

QQ登录

只需一步,快速开始

AutoCAD 2022 开发者帮助

Mirror3D 方法 (ActiveX)

2024-5-18 18:44| 发布者: admin| 查看: 13| 评论: 0|原作者: admin|来自: AutoCAD

Mirror3D 方法 (ActiveX)

创建给定对象关于平面的镜像。

支持的平台:仅限 Windows

签名

VBA:

RetVal = object.Mirror3D(Point1, Point2, Point3)
对象

类型:所有绘图对象AttributeReference尺寸

此方法应用到的对象。

第1点

访问:仅输入

类型:变体(双打的三元素阵列)

指定镜像平面第一点的 3D WCS 坐标。

第2点

访问:仅输入

类型:变体(双打的三元素阵列)

指定镜像平面的第二个点的 3D WCS 坐标。

第3点

访问:仅输入

类型:变体(双打的三元素阵列)

指定镜像平面第三点的 3D WCS 坐标。

返回值 (RetVal)

类型:对象

此对象可以是任何图形对象之一,并且是镜像原始对象的结果。

言论

围绕由三点定义的平面镜像的对象

AutoCAD 会检查要复制的对象是否拥有任何其他对象。如果是这样,它也会对这些对象执行复制。该过程将继续进行,直到复制了所有拥有的对象。

注意:不能在同时循环访问集合时执行此方法。迭代将为只读操作打开工作空间,而此方法将尝试执行读写操作。在调用此方法之前,请完成任何迭代。

AttributeReference:不应尝试在对象上使用此方法。 对象继承此方法,因为它们是绘图对象之一,但是,对属性参照执行此操作是不可行的。AttributeReferenceAttributeReference

例子

VBA:

Sub Example_Mirror3D()
    ' This example creates a box in model space, and mirrors the box about a plane.
    
    Dim boxObj As Acad3DSolid
    Dim length As Double, width As Double, height As Double
    Dim center(0 To 2) As Double
    
    ' Define the box
    center(0) = 5#: center(1) = 5#: center(2) = 0
    length = 5#: width = 7: height = 10#
    
    ' Create the box (3DSolid) object in model space
    Set boxObj = ThisDrawing.ModelSpace.AddBox(center, length, width, height)
    
    ' Define the mirroring plane with three points
    Dim mirrorPt1(0 To 2) As Double
    Dim mirrorPt2(0 To 2) As Double
    Dim mirrorPt3(0 To 2) As Double
    
    mirrorPt1(0) = 1.25: mirrorPt1(1) = 0: mirrorPt1(2) = 0
    mirrorPt2(0) = 1.25: mirrorPt2(1) = 2: mirrorPt2(2) = 0
    mirrorPt3(0) = 1.25: mirrorPt3(1) = 2: mirrorPt3(2) = 2
    
    ' Mirror the box
    Dim mirrorBoxObj As Acad3DSolid
    Set mirrorBoxObj = boxObj.Mirror3D(mirrorPt1, mirrorPt2, mirrorPt3)
    
    ' Change the viewing direction of the viewport
    Dim NewDirection(0 To 2) As Double
    NewDirection(0) = -1: NewDirection(1) = -1: NewDirection(2) = 1
    ThisDrawing.ActiveViewport.direction = NewDirection
    ThisDrawing.ActiveViewport = ThisDrawing.ActiveViewport
    ZoomAll
    
End Sub

可视化 LISP:

(vl-load-com)
(defun c:Example_Mirror3D()
    ;; This example creates a box in model space, and mirrors the box about a plane.
    (setq acadObj (vlax-get-acad-object))
    (setq doc (vla-get-ActiveDocument acadObj))
    
    ;; Define the box
    (setq center (vlax-3d-point 5 5 0)
          boxLength 5
	         boxWidth 7
	         boxHeight 10)
    
    ;; Create the box (3DSolid) object in model space
    (setq modelSpace (vla-get-ModelSpace doc))
    (setq boxObj (vla-AddBox modelSpace center boxLength boxWidth boxHeight))
    
    ;; Define the mirroring plane with three points
    (setq mirrorPt1 (vlax-3d-point 1.25 0 0)
          mirrorPt2 (vlax-3d-point 1.25 2 0)
          mirrorPt3 (vlax-3d-point 1.25 2 2))
    
    ;; Mirror the box
    (setq mirrorBoxObj (vla-Mirror3D boxObj mirrorPt1 mirrorPt2 mirrorPt3))
    
    ;; Change the viewing direction of the viewport
    (setq NewDirection (vlax-3d-point -1 -1 1))
    (setq activeViewport (vla-get-ActiveViewport doc))
    (vla-put-Direction activeViewport NewDirection)
    (vla-put-ActiveViewport doc activeViewport)
    (vla-ZoomAll acadObj)
)

路过

雷人

握手

鲜花

鸡蛋

最新评论

QQ|Archiver|CAD开发者社区 ( 苏ICP备2022047690号-1 )

GMT+8, 2024-6-27 15:51

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

返回顶部